unit UVStop;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QMenus, QStdCtrls, QExtCtrls, QTypes;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Nastaven1: TMenuItem;
    Konec1: TMenuItem;
    Obtnost1: TMenuItem;
    Potenskore1: TMenuItem;
    Lehk1: TMenuItem;
    Tk1: TMenuItem;
    N51: TMenuItem;
    N101: TMenuItem;
    N151: TMenuItem;
    Zvuky1: TMenuItem;
    Pauza1: TMenuItem;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Npovda1: TMenuItem;
    Label7: TLabel;
    Timer2: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Pauza1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Zvuky1Click(Sender: TObject);
    procedure Lehk1Click(Sender: TObject);
    procedure Tk1Click(Sender: TObject);
    procedure N51Click(Sender: TObject);
    procedure N101Click(Sender: TObject);
    procedure N151Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Npovda1Click(Sender: TObject);
  private
    { Private declarations }
  KonHry,T2Kon,Ozvuc,Paus,Hra,Prem:boolean;
  C1,C2,C3,Obtiz,Body,Im1R,Im2R,Im3R,BInt,BCit,Im1Cit,Im2Cit,Im3Cit:byte;
  VObtiz,VBody:byte;
  Skore:longint;
  VSkore:longint;
  procedure NahRychlost;
  procedure LFRF(Obraz:TImage;var Jmeno:byte);
  procedure NaStartu;
  procedure NaKonci;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses u_help;

{$R *.dfm}

const Rychlost:array [1..6] of byte=(3,18,108,3,4,5);  //rychlost pro hrac pole

procedure TForm1.FormCreate(Sender: TObject);  //nastaven pi sputn programu
begin
Paus:=False;   //pauza nen
Ozvuc:=True;   //zvuk je
VObtiz:=0; //obtnost jednoduch
VBody:=10;     //vchoz poet bod
VSkore:=10;    //poten skre
T2Kon:=True;   //je konec zprvy o vsledku - nen zobrazena
NaStartu;  //nastavm do stavu ped startem hry
end;

procedure TForm1.NaStartu;  //nastaven ped zatkem hry
begin
Prem:=False;   //prmie nen
Hra:=False;    //hra nen
KonHry:=False; //konec hry nen
C1:=5;         //obrazek image1 -1
LFRF(Image1,C1);  //nataen obrzku z resource file
C2:=5;         //obrazek image2 -1
LFRF(Image2,C2);  //nataen obrzku z resource file
C3:=5;         //obrazek image3 -1
LFRF(Image3,C3);  //nataen obrzku z resource file
Label6.Caption:=IntToStr(VBody);  //zobrazen potu bod
Label3.Caption:=IntToStr(VSkore);  //zobrazen skre
end;

procedure TForm1.NaKonci;  //akce pi skonen hry
var TextBoxu:string;
begin
TextBoxu:='Tvoje dosazene skore je '+IntToStr(Skore);  //text zprvy o vsledku
if Prem then TextBoxu:=textboxu+', a mas PREMII.'  //pidn textu s prmi
        else TextBoxu:=textboxu+'.';
Application.MessageBox(TextBoxu,'Konec hry',[smbOK]);  //zprva o vsledku - petypovn!
Label4.Caption:=IntToStr(Skore);  //vsledn skre jako skre z minul hry
Obtnost1.Enabled:=True;  //mu mnit nastaven obtnosti
Potenskore1.Enabled:=True;  //a potenho skre
Button1.Caption:='START';  //nadpis tlatka
Button1.Enabled:=True;  //jde stisknout
Button1.Setfocus;  //je zamen
NaStartu;  //nastavm do stavu ped startem hry
end;

procedure TForm1.NahRychlost;  //nhodn vybere nastaven hracch pol
var A,B,C:byte;
begin
Randomize;       //nhodn vbr rychlost - indexy do pole rychlost z {1,2,3}
A:=Random(3)+1;  //A,B nhodn, C dopotm, B ppadn upravm (A<>B<>C)
B:=Random(2)+1;
if A=B then
  if A=1 then
    begin
    {A=1}
    B:=2;
    C:=3;
    end
  else
    begin
    {A=2}
    B:=3;
    C:=1;
    end
else
  if A=3 then C:=3-B
         else C:=3;
BInt:=1;  //index pro interval pro zvuk - jako nejrychle pole
BInt:=BInt+Obtiz*3;  //prava podle vybran obtnosti
A:=A+Obtiz*3;
B:=B+Obtiz*3;
C:=C+Obtiz*3;
BInt:=Rychlost[BInt];  //interval pro zvuk
BCit:=1;               //ta zvuku
Im1R:=Rychlost[A];  //rychlost 1. hracho pole
Im2R:=Rychlost[B];  //rychlost 2. hracho pole
Im3R:=Rychlost[C];  //rychlost 3. hracho pole
Randomize;
C1:=Random(6);  //nhodn prvn obrzek pro jednotliv hrac pole -1
C2:=Random(6);
C3:=Random(6);
LFRF(Image1,C1);  //nataen obrzk z resource file
LFRF(Image2,C2);
LFRF(Image3,C3);
Randomize;  //nhodn nastaven poten hodnoty ta pro jednotliv hrac pole
Im1Cit:=Random(Im1R);
Im2Cit:=Random(Im2R);
Im3Cit:=Random(Im3R);
end;

procedure TForm1.LFRF(Obraz:TImage;var Jmeno:byte);  //nahrn obrzk z resource file
begin
Jmeno:=(Jmeno mod 6)+1;  //posunu slo obrzku
case Jmeno of  //podle sla obrzku nahraji odpovdajc obrzek do pslunho hracho pole
  1:Obraz.Picture.Bitmap.LoadFromResourceName(HInstance,'JEDNICKA');
  2:Obraz.Picture.Bitmap.LoadFromResourceName(HInstance,'DVOJKA');
  3:Obraz.Picture.Bitmap.LoadFromResourceName(HInstance,'TROJKA');
  4:Obraz.Picture.Bitmap.LoadFromResourceName(HInstance,'CTYRKA');
  5:Obraz.Picture.Bitmap.LoadFromResourceName(HInstance,'PETKA');
  6:Obraz.Picture.Bitmap.LoadFromResourceName(HInstance,'SESTKA');
  end;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
Close;  //konec programu
end;

procedure TForm1.Pauza1Click(Sender: TObject);  //vbr pauzy
begin
if Paus then  //ukonen pauzy
  begin
  Form1.Caption:='VirtualStop';  //zmna nadpisu formu
  if (T2Kon and (not KonHry)) then  //skonil vpis zprvy o vsledku a nen konec hry
    begin
    Button1.Enabled:=True;  //tlatko jde stisknout
    Button1.Setfocus;  //a je zamen
    end;
  if Hra then  //pokud probh hra
    begin
    if not KonHry then  //kdy nen konec hry
      begin
      Timer1.Enabled:=True;  //pustm hlavn asova
      if T2Kon then NahRychlost;  //pokud skonil vpis zprvy o vsledku, rozbhnu hru
      end                                            // s novm nastavenm hracch pol
    else  //je konec hry
      begin
      if T2Kon then NaKonci;  //pokud skonila zprva o vsledku, vyvolm ukonovac akce
      end;
    end;
  end
else  //zatek pauzy
  begin
  Form1.Caption:='VirtualStop - Pauza';  //zmna nadpisu formu
  Timer1.Enabled:=False;  //zastaven hlavnho asovae
  Button1.Enabled:=False;  //tlatko nejde stisknout
  end;
Paus:=not Paus;  //upraven stavu promnn
Pauza1.Checked:=not Pauza1.Checked;  //a zatren poloky menu
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
if Hra then  //probh hra
  begin
  Body:=Body-1;  //poet bod se sn
  if ((C1=C2) and (C2=C3)) then  //vechna sla stejn
    begin
    Prem:=True;  //mme prmii
    Label7.Caption:=' PREMIE ';  //text zprvy
    Label7.Color:=clLime;  //barva labelu
    Label7.Left:=296;  //umstn labelu
    Skore:=3*Skore;  //prava skre
    end
  else  //nejsou stejn vechna sla
    if ((C1=C2) or (C2=C3) or (C3=C1)) then  //jsou stejn dv sla
      begin
      Label7.Caption:=' DVAKRAT ';  //text zprvy
      Label7.Color:=clAqua;  //barva labelu
      Label7.Left:=278;  //umstn labelu
      Skore:=Skore*2;  //prava skre
      end
    else  //kad slo je jin
      begin
      Label7.Caption:=' POLOVINA ';  //text zprvy
      Label7.Color:=clFuchsia;  //barva labelu
      Label7.Left:=271;  //umstn labelu
      Skore:=(Skore+1) div 2;  //prava skre
      end;
  if Body=0 then KonHry:=True;  //vyerpali jsme body, je konec hry
  Label7.Show;  //ukeme zprvu o vsledku
  T2Kon:=False;  //nen konec vpisu zprvy
  Timer2.Enabled:=True;  //zapneme druh asova
  Label6.Caption:=IntToStr(Body);  //prava potu bod na obrazovce
  Label3.Caption:=IntToStr(Skore);  //a skre
  Button1.Enabled:=False;  //tlatko nejde stisknout
  end
else  //zana hra
  begin
  Obtiz:=VObtiz;  //obtnost pro hru
  Body:=VBody;  //body pro hru
  Skore:=VSkore;  //vchoz skre pro hru
  Hra:=True;  //hrajeme
  NahRychlost;  //nhodn nastaven hracch pol
  Obtnost1.Enabled:=False;  //nememe mnit obtnost
  Potenskore1.Enabled:=False;  //a poten skre
  Button1.Caption:='STOP';  //zmna nadpisu tlatka
  Timer1.Enabled:=True;  //zapnme hlavn timer
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);  //hlavn asova
begin
if T2Kon then  //skonil vpis zprvy o vsledku
  begin
  Im1Cit:=Im1Cit+1;  //posunut ta
  Im2Cit:=Im2Cit+1;
  Im3Cit:=Im3Cit+1;
  if Im1Cit=Im1R then  //budeme mnit 1. obrzek
    begin
    LFRF(Image1,C1);  //nataen obrzku z resource file
    Im1Cit:=0;  //vynulovn tae
    end;
  if Im2Cit=Im2R then  //budeme mnit 2. obrzek
    begin
    LFRF(Image2,C2);  //nataen obrzku z resource file
    Im2Cit:=0;  //vynulovn tae
    end;
  if Im3Cit=Im3R then  //budeme mnit 3. obrzek
    begin
    LFRF(Image3,C3);  //nataen obrzku z resource file
    Im3Cit:=0;  //vynulovn tae
    end;
  if ((BCit=BInt) and Ozvuc) then beep;   //pokud je zapnut zvuk a mnil se nejrychlej obrzek, tak ppnut
  BCit:=(BCit mod BInt)+1;                //prava tae zvuku
  end;
end;

procedure TForm1.Zvuky1Click(Sender: TObject);  //mnm nastaven zvuku
begin
Ozvuc:=not Ozvuc;  //upraven stavu promnn
Zvuky1.Checked:=not Zvuky1.Checked;  //a zatren poloky menu
end;

procedure TForm1.Lehk1Click(Sender: TObject);  //mnm obtnost na lehkou
begin
Lehk1.Checked:=True;  //prava zatren poloek menu
Tk1.Checked:=False;
VObtiz:=0;  //upraven stavu promnn
end;

procedure TForm1.Tk1Click(Sender: TObject);  //mnm obtnost na tkou
begin
Tk1.Checked:=True;  //prava zatren poloek menu
Lehk1.Checked:=False;
VObtiz:=1;  //upraven stavu promnn
end;

procedure TForm1.N51Click(Sender: TObject);  //mnm vchoz skre na 5
begin
N51.Checked:=True;  //prava zatren poloek menu
VBody:=5;  //zmna nastaven promnnch
VSkore:=5;
Label3.Caption:='5';  //a label na formu
Label6.Caption:='5';
end;

procedure TForm1.N101Click(Sender: TObject);  //mnm vchoz skre na 10
begin
N101.Checked:=True;  //prava zatren poloek menu
VBody:=10;  //zmna nastaven promnnch
VSkore:=10;
Label3.Caption:='10';  //a label na formu
Label6.Caption:='10';
end;

procedure TForm1.N151Click(Sender: TObject);  //mnm vchoz skre na 15
begin
N151.Checked:=True;  //prava zatren poloek menu
VBody:=15;  //zmna nastaven promnnch
VSkore:=15;
Label3.Caption:='15';  //a label na formu
Label6.Caption:='15';
end;

procedure TForm1.Timer2Timer(Sender: TObject);  //druh asova - pro zobrazovn zprvy o vsledku
begin
T2Kon:=True;  //skonil vpis zprvy
Label7.Hide;  //schovn labelu
Timer2.Enabled:=False;  //vypnut druhho asovae
if KonHry then  //je konec hry
  begin
  Timer1.Enabled:=False;  //vypnut hlavnho asovae
  if not Paus then NaKonci;  //pokud nen pauza, tak proveden ukonovacch akc
  end
else  //nen konec hry
  if not Paus then  //pokud nen pauza
    begin
    NahRychlost;  //rozbhnu hru s novm nastavenm hracch pol
    Button1.Enabled:=True;  //tlatko jde stisknout
    Button1.Setfocus;  //a je zamen
    end;
end;

procedure TForm1.Npovda1Click(Sender: TObject);
begin
HelpForm.ShowModal;
end;

end.
